## org.eclipse.xsd.impl
Class XSDComplexTypeDefinitionImpl

    java.lang.Object
      org.eclipse.emf.common.notify.impl.BasicNotifierImpl
          org.eclipse.emf.ecore.impl.BasicEObjectImpl
              org.eclipse.emf.ecore.impl.EObjectImpl
                  org.eclipse.xsd.impl.XSDConcreteComponentImpl
                      org.eclipse.xsd.impl.XSDComponentImpl
                          org.eclipse.xsd.impl.XSDNamedComponentImpl
                              org.eclipse.xsd.impl.XSDRedefinableComponentImpl
                                  org.eclipse.xsd.impl.XSDTypeDefinitionImpl
                                      org.eclipse.xsd.impl.XSDComplexTypeDefinitionImpl

All Implemented Interfaces:
  Notifier, EObject, InternalEObject, XSDComplexTypeDefinition, XSDComponent, XSDConcreteComponent, XSDNamedComponent, XSDRedefinableComponent, XSDRedefineContent, XSDSchemaContent, XSDScope, XSDTypeDefinition

    public class XSDComplexTypeDefinitionImpl

extends XSDTypeDefinitionImpl
implements XSDComplexTypeDefinition

An implementation of the model object 'Complex Type Definition'.

The following features are implemented:

- `Derivation Method`
- `Final`
- `Abstract`
- `Content Type Category`
- `Prohibited Substitutions`
- `Lexical Final`
- `Block`
- `Mixed`
- `Content Annotation`
- `Base Type Definition`
- `Content`
- `Content Type`
- `Attribute Uses`
- `Attribute Contents`
- `Attribute Wildcard`
- `Attribute Wildcard Content`
- `Root Type Definition`
- `Synthetic Particle`
- `Synthetic Wildcard`

Nested Class Summary

Nested classes/interfaces inherited from class org.eclipse.xsd.impl.XSDNamedComponentImpl
`XSDNamedComponentImpl.Comparator, XSDNamedComponentImpl.StringPairComparator, XSDNamedComponentImpl.XSDNamedComponentList<E extends java.lang.Object & XSDNamedComponent>`

Nested classes/interfaces inherited from class org.eclipse.xsd.impl.XSDConcreteComponentImpl
`XSDConcreteComponentImpl.XSDContentsEList`

Nested classes/interfaces inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl
`BasicEObjectImpl.EPropertiesHolder, BasicEObjectImpl.EPropertiesHolderBaseImpl, BasicEObjectImpl.EPropertiesHolderImpl`

Nested classes/interfaces inherited from class org.eclipse.emf.common.notify.impl.BasicNotifierImpl
`BasicNotifierImpl.EAdapterList<E extends java.lang.Object & Adapter>`

Nested classes/interfaces inherited from interface org.eclipse.emf.ecore.InternalEObject
`InternalEObject.EStore`

Field Summary
`protected static boolean` `ABSTRACT_EDEFAULT` The default value of the '`Abstract`' attribute
`protected static int` `ABSTRACT_EFLAG` The flag representing the value of the '`Abstract`' attribute
`protected static int` `ABSTRACT_ESETFLAG` The flag representing whether the Abstract attribute has been set
`protected EList<XSDAttributeGroupContent>` `attributeContents` The cached value of the '`Attribute Contents`' containment reference list
`protected EList<XSDAttributeUse>` `attributeUses` The cached value of the '`Attribute Uses`' reference list
`protected XSDWildcard` `attributeWildcard` The cached value of the '`Attribute Wildcard`' reference
`protected XSDWildcard` `attributeWildcardContent` The cached value of the '`Attribute Wildcard Content`' containment reference
`protected XSDTypeDefinition` `baseTypeDefinition` The cached value of the '`Base Type Definition`' reference
`protected EList<XSDProhibitedSubstitutions>` `block` The cached value of the '`Block`' attribute list
`protected XSDComplexTypeContent` `content` The cached value of the '`Content`' containment reference
`protected static XSDContentTypeCategory` `CONTENT_TYPE_CATEGORY_EDEFAULT` The default value of the '`Content Type Category`' attribute
`protected static int` `CONTENT_TYPE_CATEGORY_EFLAG` The flags representing the value of the '`Content Type Category`' attribute
`protected static int` `CONTENT_TYPE_CATEGORY_EFLAG_DEFAULT` The flags representing the default value of the '`Content Type Category`' attribute
`protected static int` `CONTENT_TYPE_CATEGORY_EFLAG_OFFSET` The offset of the flags representing the value of the '`Content Type Category`' attribute
`protected XSDAnnotation` `contentAnnotation` The cached value of the '`Content Annotation`' containment reference
`protected XSDComplexTypeContent` `contentType` The cached value of the '`Content Type`' reference
`protected static XSDDerivationMethod` `DERIVATION_METHOD_EDEFAULT` The default value of the '`Derivation Method`' attribute
`protected static int` `DERIVATION_METHOD_EFLAG` The flag representing the value of the '`Derivation Method`' attribute
`protected static int` `DERIVATION_METHOD_EFLAG_DEFAULT` The flags representing the default value of the '`Derivation Method`' attribute
`protected static int` `DERIVATION_METHOD_EFLAG_OFFSET` The offset of the flags representing the value of the '`Derivation Method`' attribute
`protected static int` `DERIVATION_METHOD_ESETFLAG` The flag representing whether the Derivation Method attribute has been set
`protected XSDWildcardImpl` `effectiveWildcard`
`protected XSDParticle` `extensionParticle`
`protected EList<XSDComplexFinal>` `final_` The cached value of the '`Final`' attribute list
`protected EList<XSDComplexFinal>` `lexicalFinal` The cached value of the '`Lexical Final`' attribute list
`protected static boolean` `MIXED_EDEFAULT` The default value of the '`Mixed`' attribute
`protected static int` `MIXED_EFLAG` The flag representing the value of the '`Mixed`' attribute
`protected static int` `MIXED_ESETFLAG` The flag representing whether the Mixed attribute has been set
`protected EList<XSDProhibitedSubstitutions>` `prohibitedSubstitutions` The cached value of the '`Prohibited Substitutions`' attribute list
`protected XSDParticle` `syntheticParticle` The cached value of the '`Synthetic Particle`' containment reference
`protected XSDWildcard` `syntheticWildcard` The cached value of the '`Synthetic Wildcard`' containment reference

Fields inherited from class org.eclipse.xsd.impl.XSDTypeDefinitionImpl
`analysisState, annotation, annotations, derivationAnnotation`

Fields inherited from class org.eclipse.xsd.impl.XSDRedefinableComponentImpl
`CIRCULAR_EDEFAULT`

Fields inherited from class org.eclipse.xsd.impl.XSDNamedComponentImpl
`ALIAS_NAME_EDEFAULT, ALIAS_URI_EDEFAULT, name, NAME_EDEFAULT, QNAME_EDEFAULT, TARGET_NAMESPACE_EDEFAULT, targetNamespace, URI_EDEFAULT`

Fields inherited from class org.eclipse.xsd.impl.XSDConcreteComponentImpl
`ANALYZED, ANALYZING, CIRCULAR, diagnostics, element, ELEMENT_EDEFAULT, ERROR, FATAL, forceResolve, INFORMATION, isReconciling, UNANALYZED, updatingDOM, WARNING, xsdContents`

Fields inherited from class org.eclipse.emf.ecore.impl.EObjectImpl
`eAdapters, eContainer, eContainerFeatureID, EDELIVER, EDYNAMIC_CLASS, eFlags, ELAST_EOBJECT_FLAG, ELAST_NOTIFIER_FLAG, eProperties, EPROXY`

Fields inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl
`EVIRTUAL_GET, EVIRTUAL_IS_SET, EVIRTUAL_NO_VALUE, EVIRTUAL_SET, EVIRTUAL_UNSET`

Fields inherited from interface org.eclipse.emf.ecore.InternalEObject
`EOPPOSITE_FEATURE_BASE`

Constructor Summary
`protected` `XSDComplexTypeDefinitionImpl()`

Method Summary
`protected boolean` `abbreviate()`
`protected void` `adoptContent(EReference eReference, XSDConcreteComponent xsdConcreteComponent)`
`NotificationChain` `basicSetAttributeWildcardContent(XSDWildcard newAttributeWildcardContent, NotificationChain msgs)`
`NotificationChain` `basicSetContent(XSDComplexTypeContent newContent, NotificationChain msgs)`
`NotificationChain` `basicSetContentAnnotation(XSDAnnotation newContentAnnotation, NotificationChain msgs)`
`NotificationChain` `basicSetSyntheticParticle(XSDParticle newSyntheticParticle, NotificationChain msgs)`
`NotificationChain` `basicSetSyntheticWildcard(XSDWildcard newSyntheticWildcard, NotificationChain msgs)`
`protected void` `changeAttribute(EAttribute eAttribute)`
`protected void` `changeReference(EReference eReference)`
`XSDConcreteComponent` `cloneConcreteComponent(boolean deep, boolean shareDOM)` Creates a clone of the component.
`protected boolean` `considerAllContainsForBestConcreteComponent()`
`static XSDComplexTypeDefinition` `createComplexTypeDefinition(org.w3c.dom.Node node)`
`protected org.w3c.dom.Element[]` `createContentElementPair()`
`protected org.w3c.dom.Element` `createDerivationElement()`
`org.w3c.dom.Element` `createElement()`
`java.lang.Object` `eGet(int featureID, boolean resolve, boolean coreType)`
`NotificationChain` `eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)`
`boolean` `eIsSet(int featureID)`
`void` `eSet(int featureID, java.lang.Object newValue)`
`protected EClass` `eStaticClass()`
`void` `eUnset(int featureID)`
`protected org.w3c.dom.Element[]` `findOrCreateContentElementPair()`
`protected org.w3c.dom.Node` `getAdoptionParentNode(EReference eReference)`
`EList<XSDAttributeGroupContent>` `getAttributeContents()`
`EList<XSDAttributeUse>` `getAttributeUses()`
`XSDWildcard` `getAttributeWildcard()`
`XSDWildcard` `getAttributeWildcardContent()`
`XSDTypeDefinition` `getBadTypeDerivation(XSDTypeDefinition xsdTypeDefinition, boolean extension, boolean restriction)` Returns the first type between this and the given one, that derives from it's base in a way not permitted as constrained by Type Derivation OK Complex and Simple.
`XSDTypeDefinition` `getBaseType()` Returns the value of the 'Base Type' reference
`XSDTypeDefinition` `getBaseTypeDefinition()`
`EList<XSDProhibitedSubstitutions>` `getBlock()`
`XSDParticle` `getComplexType()`
`XSDComplexTypeContent` `getContent()`
`XSDAnnotation` `getContentAnnotation()`
`protected org.w3c.dom.Element[]` `getContentElementPair()`
`protected java.util.Collection<org.w3c.dom.Element>` `getContentNodes(org.w3c.dom.Element changedElement)`
`XSDComplexTypeContent` `getContentType()`
`XSDContentTypeCategory` `getContentTypeCategory()`
`XSDDerivationMethod` `getDerivationMethod()`
`EList<XSDComplexFinal>` `getFinal()`
`EList<XSDComplexFinal>` `getLexicalFinal()`
`protected static java.util.Map<java.lang.String,XSDAttributeDeclaration>` `getProhibitedAttributes(java.util.Collection<XSDAttributeGroupContent> xsdAttributeContents)`
`protected static java.util.Map<java.lang.String,XSDAttributeDeclaration>` `getProhibitedAttributeURIs(XSDComplexTypeDefinition xsdComplexTypeDefinition)`
`EList<XSDProhibitedSubstitutions>` `getProhibitedSubstitutions()`
`XSDTypeDefinition` `getRootType()` Returns the value of the 'Root Type' reference
`XSDTypeDefinition` `getRootTypeDefinition()` Returns the value of the 'Root Type Definition' reference
`XSDSimpleTypeDefinition` `getSimpleType()` Returns the value of the 'Simple Type' reference
`java.lang.String` `getStringBlock()` Returns the String value of the '`Block`' attribute list
`java.lang.String` `getStringFinal()` Returns the String value of the '`Final`' attribute list
`java.lang.String` `getStringLexicalFinal()` Returns the String value of the '`Lexical Final`' attribute list
`java.lang.String` `getStringProhibitedSubstitutions()` Returns the String value of the '`Prohibited Substitutions`' attribute list
`XSDParticle` `getSyntheticParticle()`
`XSDWildcard` `getSyntheticWildcard()`
`protected void` `handleAnalysis()`
`protected XSDTypeDefinition` `handleNewBaseTypeDefinition(XSDTypeDefinition newBaseTypeDefinition)`
`protected void` `handleReconciliation(java.util.List<XSDConcreteComponent> newContents, java.util.List<XSDConcreteComponent> remainingContents)`
`protected void` `handleUnreconciledElement(org.w3c.dom.Element child, java.util.List<XSDConcreteComponent> newContents, java.util.List<XSDConcreteComponent> remainingContents)`
`boolean` `isAbstract()`
`protected boolean` `isEmptyContent(XSDParticle xsdParticle)`
`boolean` `isMixed()`
`boolean` `isSetAbstract()`
`boolean` `isSetBlock()`
`boolean` `isSetDerivationMethod()`
`boolean` `isSetLexicalFinal()`
`boolean` `isSetMixed()`
`protected void` `orphanContent(EReference eReference, XSDConcreteComponent xsdConcreteComponent)`
`protected void` `patch()`
`protected void` `reconcileAttributes(org.w3c.dom.Element changedElement)`
`void` `setAbstract(boolean newAbstract)`
`void` `setAttributeWildcard(XSDWildcard newAttributeWildcard)`
`void` `setAttributeWildcardContent(XSDWildcard newAttributeWildcardContent)`
`void` `setBaseTypeDefinition(XSDTypeDefinition newBaseTypeDefinition)`
`void` `setContent(XSDComplexTypeContent newContent)`
`void` `setContentAnnotation(XSDAnnotation newContentAnnotation)`
`void` `setContentType(XSDComplexTypeContent newContentType)`
`void` `setContentTypeCategory(XSDContentTypeCategory newContentTypeCategory)`
`void` `setDerivationMethod(XSDDerivationMethod newDerivationMethod)`
`void` `setMixed(boolean newMixed)`
`void` `setStringBlock(java.lang.String block)` Sets the String value of the '`Block`' attribute
`void` `setStringLexicalFinal(java.lang.String finalDefault)` Sets the String value of the '`Lexical Final`' attribute
`void` `setSyntheticParticle(XSDParticle newSyntheticParticle)`
`void` `setSyntheticWildcard(XSDWildcard newSyntheticWildcard)`
`java.lang.String` `toString()`
`void` `unsetAbstract()`
`void` `unsetBlock()`
`void` `unsetDerivationMethod()`
`void` `unsetLexicalFinal()`
`void` `unsetMixed()`
`void` `validate()` Validates whether this component conforms to the constraints defined in the XML Schema standard.
`static void` `validateAttributeGroup(XSDConcreteComponentImpl xsdConcreteComponent, XSDWildcard containedWildcard, EList<XSDAttributeUse> baseXSDAttributeUses, EList<XSDAttributeUse> xsdAttributeUses, XSDWildcard baseXSDWildcard, XSDWildcard xsdWildcard)`

Methods inherited from class org.eclipse.xsd.impl.XSDTypeDefinitionImpl
`analyze, basicSetAnnotation, basicSetDerivationAnnotation, createTypeDefinition, getAnnotation, getAnnotations, getDerivationAnnotation, getLowestCommonAncestor, isCircular, setAnnotation, setDerivationAnnotation`

Methods inherited from class org.eclipse.xsd.impl.XSDRedefinableComponentImpl
`getCircular`

Methods inherited from class org.eclipse.xsd.impl.XSDNamedComponentImpl

`addToSortedList, adoptBy, findInSortedList, getAliasName, getAliasURI, getName, getQName, getQName, getResolvedNamedComponent, getTargetNamespace, getURI, getURIReferenceLabel, hasNameAndTargetNamespace, hasSameNameAndTargetNamespace, hasURI, isNamedComponentReference, mergeToSortedList, patchTargetNamespaceAttribute, patchTargetNamespaceAttribute, reconcileNameAttribute, setName, setTargetNamespace, sortNamedComponents`

Methods inherited from class org.eclipse.xsd.impl.XSDConcreteComponentImpl

`adoptDiagnostic, checkAttributes, checkAttributeTypeConstraint, checkAttributeTypeConstraint, checkBuiltInTypeConstraint, checkComplexContent, checkComplexContent, checkElementComplexContent, checkSimpleTypeConstraint, clearDiagnostics, cloneConcreteComponents, contains, convertToBoolean, createDiagnostic, createDiagnostic, createDiagnostic, createDiagnostic, createElement, createRequiredAttributeDiagnostic, createUnresolvedAttributeDeclaration, createUnresolvedAttributeGroupDefinition, createUnresolvedComplexTypeDefinition, createUnresolvedElementDeclaration, createUnresolvedIdentityConstraintDefinition, createUnresolvedModelGroupDefinition, createUnresolvedNotationDeclaration, createUnresolvedSimpleTypeDefinition, createUnresolvedTypeDefinition, elementAttributesChanged, elementChanged, elementContentsChanged, eNotificationRequired, eNotify, eObjectForURIFragmentSegment, eURIFragmentSegment, forceEngulf, forceEngulf, forceNiceInsertBefore, forceNiceRemoveChild, forceReplace, getBestConcreteComponent, getComponentsWithApplicationInformation, getComponentsWithInformation, getComponentsWithUserInformation, getContainer, getDiagnostics, getDiagnosticTarget, getElement, getRootContainer, getSchema, getXSDConcreteComponentImpls, getXSDContents, getXSDFactory, getXSDPackage, handleAnnotationReconciliation, handleElementForAdopt, isUpdatingDOM, moveContent, niceCreateNamespaceAttribute, niceInsertBefore, niceRemoveChild, niceSetAttribute, niceSetAttributeURIValue, orphanBy, orphanDiagnostic, populateDiagnostic, printDFA, reconcile, reconcileContents, reportConstraintViolation, reset, resolveAttributeDeclaration, resolveAttributeDeclaration, resolveAttributeDeclarationURI, resolveAttributeGroupDefinition, resolveAttributeGroupDefinition, resolveAttributeGroupDefinitionURI, resolveComplexTypeDefinition, resolveComplexTypeDefinition, resolveComplexTypeDefinitionURI, resolveElementDeclaration, resolveElementDeclaration, resolveElementDeclarationURI, resolveIdentityConstraintDefinition, resolveIdentityConstraintDefinition, resolveIdentityConstraintDefinitionURI, resolveModelGroupDefinition, resolveModelGroupDefinition, resolveModelGroupDefinitionURI, resolveNotationDeclaration, resolveNotationDeclaration, resolveNotationDeclarationURI, resolveSimpleTypeDefinition, resolveSimpleTypeDefinition, resolveSimpleTypeDefinitionURI, resolveTypeDefinition, resolveTypeDefinition, resolveTypeDefinitionURI, setElement, setElementGen, setListContentAndOrder, traverseToRootForAnalysis, traverseToRootForPatching, updateElement, updateElement, updatePrefix`

Methods inherited from class org.eclipse.emf.ecore.impl.EObjectImpl
`eAdapters, eBasicAdapters, eBasicProperties, eBasicSetContainer, eClass, eContainerFeatureID, eDeliver, eInternalContainer, eIsProxy, eProperties, eSetClass, eSetDeliver, eSetProxyURI`

Methods inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl

`eAddVirtualValue, eAllContents, eBaseStructuralFeatureID, eBasicRemoveFromContainer, eBasicRemoveFromContainerFeature, eBasicSetContainer, eComputeVirtualValuesCapacity, eContainer, eContainingFeature, eContainmentFeature, eContainmentFeature, eContains, eContents, eCrossReferences, eDerivedStructuralFeatureID, eDerivedStructuralFeatureID, eDirectResource, eDynamicBasicRemoveFromContainer, eDynamicClass, eDynamicFeature, eDynamicFeatureID, eDynamicGet, eDynamicGet, eDynamicGet, eDynamicInverseAdd, eDynamicInverseAdd, eDynamicInverseRemove, eDynamicInverseRemove, eDynamicIsSet, eDynamicIsSet, eDynamicIsSet, eDynamicSet, eDynamicSet, eDynamicSet, eDynamicUnset, eDynamicUnset, eDynamicUnset, eGet, eGet, eGet, eHasSettings, eInternalResource, eInverseAdd, eInverseAdd, eInverseRemove, eIsSet, eOpenGet, eOpenIsSet, eOpenSet, eOpenUnset, eProxyURI, eRemoveVirtualValue, eResolveProxy, eResource, eSet, eSetDirectResource, eSetResource, eSetStore, eSetting, eSettingDelegate, eSettings, eSetVirtualIndexBits, eSetVirtualValue, eSetVirtualValues, eStaticFeatureCount, eStore, eUnset, eVirtualBitCount, eVirtualGet, eVirtualGet, eVirtualIndex, eVirtualIndexBits, eVirtualIsSet, eVirtualSet, eVirtualUnset, eVirtualValue, eVirtualValues`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.eclipse.xsd.XSDTypeDefinition
`getAnnotation, getAnnotations, getDerivationAnnotation, setAnnotation, setDerivationAnnotation`

Methods inherited from interface org.eclipse.xsd.XSDRedefinableComponent
`isCircular`

Methods inherited from interface org.eclipse.xsd.XSDNamedComponent
`getAliasName, getAliasURI, getName, getQName, getQName, getTargetNamespace, getURI, hasNameAndTargetNamespace, hasSameNameAndTargetNamespace, hasURI, setName, setTargetNamespace`

Methods inherited from interface org.eclipse.xsd.XSDConcreteComponent

`clearDiagnostics, contains, elementAttributesChanged, elementChanged, elementContentsChanged, getComponentsWithApplicationInformation, getComponentsWithUserInformation, getContainer, getDiagnostics, getElement, getRootContainer, getSchema, resolveAttributeDeclaration, resolveAttributeDeclaration, resolveAttributeDeclarationURI, resolveAttributeGroupDefinition, resolveAttributeGroupDefinition, resolveAttributeGroupDefinitionURI, resolveComplexTypeDefinition, resolveComplexTypeDefinition, resolveComplexTypeDefinitionURI, resolveElementDeclaration, resolveElementDeclaration, resolveElementDeclarationURI, resolveIdentityConstraintDefinition, resolveIdentityConstraintDefinition, resolveIdentityConstraintDefinitionURI, resolveModelGroupDefinition, resolveModelGroupDefinition, resolveModelGroupDefinitionURI, resolveNotationDeclaration, resolveNotationDeclaration, resolveNotationDeclarationURI, resolveSimpleTypeDefinition, resolveSimpleTypeDefinition, resolveSimpleTypeDefinitionURI, resolveTypeDefinition, resolveTypeDefinition, resolveTypeDefinitionURI, setElement, updateElement, updateElement`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Methods inherited from interface org.eclipse.xsd.XSDConcreteComponent

`clearDiagnostics, contains, elementAttributesChanged, elementChanged, elementContentsChanged, getComponentsWithApplicationInformation, getComponentsWithUserInformation, getContainer, getDiagnostics, getElement, getRootContainer, getSchema, resolveAttributeDeclaration, resolveAttributeDeclaration, resolveAttributeDeclarationURI, resolveAttributeGroupDefinition, resolveAttributeGroupDefinition, resolveAttributeGroupDefinitionURI, resolveComplexTypeDefinition, resolveComplexTypeDefinition, resolveComplexTypeDefinitionURI, resolveElementDeclaration, resolveElementDeclaration, resolveElementDeclarationURI, resolveIdentityConstraintDefinition, resolveIdentityConstraintDefinition, resolveIdentityConstraintDefinitionURI, resolveModelGroupDefinition, resolveModelGroupDefinition, resolveModelGroupDefinitionURI, resolveNotationDeclaration, resolveNotationDeclaration, resolveNotationDeclarationURI, resolveSimpleTypeDefinition, resolveSimpleTypeDefinition, resolveSimpleTypeDefinitionURI, resolveTypeDefinition, resolveTypeDefinition, resolveTypeDefinitionURI, setElement, updateElement, updateElement`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Field Detail

### DERIVATION_METHOD_EDEFAULT

    protected static final XSDDerivationMethod DERIVATION_METHOD_EDEFAULT

  The default value of the '`Derivation Method`' attribute.

  See Also:
    `getDerivationMethod()`

### DERIVATION_METHOD_EFLAG_OFFSET

    protected static final int DERIVATION_METHOD_EFLAG_OFFSET

  The offset of the flags representing the value of the '`Derivation Method`' attribute.

  See Also:
    Constant Field Values

### DERIVATION_METHOD_EFLAG_DEFAULT

    protected static final int DERIVATION_METHOD_EFLAG_DEFAULT

  The flags representing the default value of the '`Derivation Method`' attribute.

### DERIVATION_METHOD_EFLAG

    protected static final int DERIVATION_METHOD_EFLAG

  The flag representing the value of the '`Derivation Method`' attribute.

  See Also:
    `getDerivationMethod()`, Constant Field Values

### DERIVATION_METHOD_ESETFLAG

    protected static final int DERIVATION_METHOD_ESETFLAG

  The flag representing whether the Derivation Method attribute has been set.

  See Also:
    Constant Field Values

### final_

    protected EList<XSDComplexFinal> final_

  The cached value of the '`Final`' attribute list.

  See Also:
    `getFinal()`

### ABSTRACT_EDEFAULT

    protected static final boolean ABSTRACT_EDEFAULT

  The default value of the '`Abstract`' attribute.

  See Also:
    `isAbstract()`, Constant Field Values

### ABSTRACT_EFLAG

    protected static final int ABSTRACT_EFLAG

  The flag representing the value of the '`Abstract`' attribute.

  See Also:
    `isAbstract()`, Constant Field Values

### ABSTRACT_ESETFLAG

    protected static final int ABSTRACT_ESETFLAG

  The flag representing whether the Abstract attribute has been set.

  See Also:
    Constant Field Values

### CONTENT_TYPE_CATEGORY_EDEFAULT

    protected static final XSDContentTypeCategory CONTENT_TYPE_CATEGORY_EDEFAULT

  The default value of the '`Content Type Category`' attribute.

  See Also:
    `getContentTypeCategory()`

### CONTENT_TYPE_CATEGORY_EFLAG_OFFSET

    protected static final int CONTENT_TYPE_CATEGORY_EFLAG_OFFSET

  The offset of the flags representing the value of the '`Content Type Category`' attribute.

  See Also:
    Constant Field Values

### CONTENT_TYPE_CATEGORY_EFLAG_DEFAULT

    protected static final int CONTENT_TYPE_CATEGORY_EFLAG_DEFAULT

  The flags representing the default value of the '`Content Type Category`' attribute.

### CONTENT_TYPE_CATEGORY_EFLAG

    protected static final int CONTENT_TYPE_CATEGORY_EFLAG

  The flags representing the value of the '`Content Type Category`' attribute.

  See Also:
    `getContentTypeCategory()`, Constant Field Values

### prohibitedSubstitutions

    protected EList<XSDProhibitedSubstitutions> prohibitedSubstitutions

  The cached value of the '`Prohibited Substitutions`' attribute list.

  See Also:
    `getProhibitedSubstitutions()`

### lexicalFinal

    protected EList<XSDComplexFinal> lexicalFinal

  The cached value of the '`Lexical Final`' attribute list.

  See Also:
    `getLexicalFinal()`

### block

    protected EList<XSDProhibitedSubstitutions> block

  The cached value of the '`Block`' attribute list.

  See Also:
    `getBlock()`

### MIXED_EDEFAULT

    protected static final boolean MIXED_EDEFAULT

  The default value of the '`Mixed`' attribute.

  See Also:
    `isMixed()`, Constant Field Values

### MIXED_EFLAG

    protected static final int MIXED_EFLAG

  The flag representing the value of the '`Mixed`' attribute.

  See Also:
    `isMixed()`, Constant Field Values

### MIXED_ESETFLAG

    protected static final int MIXED_ESETFLAG

  The flag representing whether the Mixed attribute has been set.

  See Also:
    Constant Field Values

### contentAnnotation

    protected XSDAnnotation contentAnnotation

  The cached value of the '`Content Annotation`' containment reference.

  See Also:
    `getContentAnnotation()`

### baseTypeDefinition

    protected XSDTypeDefinition baseTypeDefinition

  The cached value of the '`Base Type Definition`' reference.

  See Also:
    `getBaseTypeDefinition()`

### content

    protected XSDComplexTypeContent content

  The cached value of the '`Content`' containment reference.

  See Also:
    `getContent()`

### contentType

    protected XSDComplexTypeContent contentType

  The cached value of the '`Content Type`' reference.

  See Also:
    `getContentType()`

### attributeUses

    protected EList<XSDAttributeUse> attributeUses

  The cached value of the '`Attribute Uses`' reference list.

  See Also:
    `getAttributeUses()`

### attributeContents

    protected EList<XSDAttributeGroupContent> attributeContents

  The cached value of the '`Attribute Contents`' containment reference list.

  See Also:
    `getAttributeContents()`

### attributeWildcard

    protected XSDWildcard attributeWildcard

  The cached value of the '`Attribute Wildcard`' reference.

  See Also:
    `getAttributeWildcard()`

### attributeWildcardContent

    protected XSDWildcard attributeWildcardContent

  The cached value of the '`Attribute Wildcard Content`' containment reference.

  See Also:
    `getAttributeWildcardContent()`

### syntheticParticle

    protected XSDParticle syntheticParticle

  The cached value of the '`Synthetic Particle`' containment reference.

  See Also:
    `getSyntheticParticle()`

### syntheticWildcard

    protected XSDWildcard syntheticWildcard

  The cached value of the '`Synthetic Wildcard`' containment reference.

  See Also:
    `getSyntheticWildcard()`

### extensionParticle

    protected XSDParticle extensionParticle

### effectiveWildcard

    protected XSDWildcardImpl effectiveWildcard

Constructor Detail

### XSDComplexTypeDefinitionImpl

    protected XSDComplexTypeDefinitionImpl()

Method Detail

### createComplexTypeDefinition

    public static XSDComplexTypeDefinition createComplexTypeDefinition(org.w3c.dom.Node node)

### eStaticClass

    protected EClass eStaticClass()

  Overrides:
    `eStaticClass` in class `XSDTypeDefinitionImpl`

### getDerivationMethod

    public XSDDerivationMethod getDerivationMethod()

  Specified by:
    `getDerivationMethod` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Derivation Method' attribute.
  See Also:
    `XSDDerivationMethod`, `XSDComplexTypeDefinition.isSetDerivationMethod()`, `XSDComplexTypeDefinition.unsetDerivationMethod()`, `XSDComplexTypeDefinition.setDerivationMethod(XSDDerivationMethod)`, `XSDPackage.getXSDComplexTypeDefinition_DerivationMethod()`

### setDerivationMethod

    public void setDerivationMethod(XSDDerivationMethod newDerivationMethod)

  Specified by:
    `setDerivationMethod` in interface `XSDComplexTypeDefinition`
  Parameters:
    `newDerivationMethod` - the new value of the 'Derivation Method' attribute.
  See Also:
    `XSDDerivationMethod`, `XSDComplexTypeDefinition.isSetDerivationMethod()`, `XSDComplexTypeDefinition.unsetDerivationMethod()`, `XSDComplexTypeDefinition.getDerivationMethod()`

### unsetDerivationMethod

    public void unsetDerivationMethod()

  Specified by:
    `unsetDerivationMethod` in interface `XSDComplexTypeDefinition`
  See Also:
    `XSDComplexTypeDefinition.isSetDerivationMethod()`, `XSDComplexTypeDefinition.getDerivationMethod()`, `XSDComplexTypeDefinition.setDerivationMethod(XSDDerivationMethod)`

### isSetDerivationMethod

    public boolean isSetDerivationMethod()

  Specified by:
    `isSetDerivationMethod` in interface `XSDComplexTypeDefinition`
  Returns:
    whether the value of the 'Derivation Method' attribute is set.
  See Also:
    `XSDComplexTypeDefinition.unsetDerivationMethod()`, `XSDComplexTypeDefinition.getDerivationMethod()`, `XSDComplexTypeDefinition.setDerivationMethod(XSDDerivationMethod)`

### getFinal

    public EList<XSDComplexFinal> getFinal()

  Specified by:
    `getFinal` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Final' attribute list.
  See Also:
    `XSDComplexTypeDefinition.getStringFinal()`, `XSDComplexFinal`, `XSDPackage.getXSDComplexTypeDefinition_Final()`

### isAbstract

    public boolean isAbstract()

  Specified by:
    `isAbstract` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Abstract' attribute.
  See Also:
    `XSDComplexTypeDefinition.isSetAbstract()`, `XSDComplexTypeDefinition.unsetAbstract()`, `XSDComplexTypeDefinition.setAbstract(boolean)`, `XSDPackage.getXSDComplexTypeDefinition_Abstract()`

### setAbstract

    public void setAbstract(boolean newAbstract)

  Specified by:
    `setAbstract` in interface `XSDComplexTypeDefinition`
  Parameters:
    `newAbstract` - the new value of the 'Abstract' attribute.
  See Also:
    `XSDComplexTypeDefinition.isSetAbstract()`, `XSDComplexTypeDefinition.unsetAbstract()`, `XSDComplexTypeDefinition.isAbstract()`

### unsetAbstract

    public void unsetAbstract()

  Specified by:
    `unsetAbstract` in interface `XSDComplexTypeDefinition`
  See Also:
    `XSDComplexTypeDefinition.isSetAbstract()`, `XSDComplexTypeDefinition.isAbstract()`, `XSDComplexTypeDefinition.setAbstract(boolean)`

### isSetAbstract

    public boolean isSetAbstract()

  Specified by:
    `isSetAbstract` in interface `XSDComplexTypeDefinition`
  Returns:
    whether the value of the 'Abstract' attribute is set.
  See Also:
    `XSDComplexTypeDefinition.unsetAbstract()`, `XSDComplexTypeDefinition.isAbstract()`, `XSDComplexTypeDefinition.setAbstract(boolean)`

### getContentTypeCategory

    public XSDContentTypeCategory getContentTypeCategory()

  Specified by:
    `getContentTypeCategory` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Content Type Category' attribute.
  See Also:
    `XSDContentTypeCategory`, `XSDComplexTypeDefinition.setContentTypeCategory(XSDContentTypeCategory)`, `XSDPackage.getXSDComplexTypeDefinition_ContentTypeCategory()`

### setContentTypeCategory

    public void setContentTypeCategory(XSDContentTypeCategory newContentTypeCategory)

  Specified by:
    `setContentTypeCategory` in interface `XSDComplexTypeDefinition`
  Parameters:
    `newContentTypeCategory` - the new value of the 'Content Type Category' attribute.
  See Also:
    `XSDContentTypeCategory`, `XSDComplexTypeDefinition.getContentTypeCategory()`

### getProhibitedSubstitutions

    public EList<XSDProhibitedSubstitutions> getProhibitedSubstitutions()

  Specified by:
    `getProhibitedSubstitutions` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Prohibited Substitutions' attribute list.
  See Also:
    `XSDComplexTypeDefinition.getStringProhibitedSubstitutions()`, `XSDProhibitedSubstitutions`, `XSDPackage.getXSDComplexTypeDefinition_ProhibitedSubstitutions()`

### getLexicalFinal

    public EList<XSDComplexFinal> getLexicalFinal()

  Specified by:
    `getLexicalFinal` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Lexical Final' attribute list.
  See Also:
    `XSDComplexTypeDefinition.getStringLexicalFinal()`, `XSDComplexTypeDefinition.setStringLexicalFinal(java.lang.String)`, `XSDComplexFinal`, `XSDComplexTypeDefinition.isSetLexicalFinal()`, `XSDComplexTypeDefinition.unsetLexicalFinal()`, `XSDPackage.getXSDComplexTypeDefinition_LexicalFinal()`

### unsetLexicalFinal

    public void unsetLexicalFinal()

  Specified by:
    `unsetLexicalFinal` in interface `XSDComplexTypeDefinition`
  See Also:
    `XSDComplexTypeDefinition.isSetLexicalFinal()`, `XSDComplexTypeDefinition.getLexicalFinal()`

### isSetLexicalFinal

    public boolean isSetLexicalFinal()

  Specified by:
    `isSetLexicalFinal` in interface `XSDComplexTypeDefinition`
  Returns:
    whether the value of the 'Lexical Final' attribute list is set.
  See Also:
    `XSDComplexTypeDefinition.unsetLexicalFinal()`, `XSDComplexTypeDefinition.getLexicalFinal()`

### getBlock

    public EList<XSDProhibitedSubstitutions> getBlock()

  Specified by:
    `getBlock` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Block' attribute list.
  See Also:
    `XSDComplexTypeDefinition.getStringBlock()`, `XSDComplexTypeDefinition.setStringBlock(java.lang.String)`, `XSDProhibitedSubstitutions`, `XSDComplexTypeDefinition.isSetBlock()`, `XSDComplexTypeDefinition.unsetBlock()`, `XSDPackage.getXSDComplexTypeDefinition_Block()`

### unsetBlock

    public void unsetBlock()

  Specified by:
    `unsetBlock` in interface `XSDComplexTypeDefinition`
  See Also:
    `XSDComplexTypeDefinition.isSetBlock()`, `XSDComplexTypeDefinition.getBlock()`

### isSetBlock

    public boolean isSetBlock()

  Specified by:
    `isSetBlock` in interface `XSDComplexTypeDefinition`
  Returns:
    whether the value of the 'Block' attribute list is set.
  See Also:
    `XSDComplexTypeDefinition.unsetBlock()`, `XSDComplexTypeDefinition.getBlock()`

### isMixed

    public boolean isMixed()

  Specified by:
    `isMixed` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Mixed' attribute.
  See Also:
    `XSDComplexTypeDefinition.isSetMixed()`, `XSDComplexTypeDefinition.unsetMixed()`, `XSDComplexTypeDefinition.setMixed(boolean)`, `XSDPackage.getXSDComplexTypeDefinition_Mixed()`

### setMixed

    public void setMixed(boolean newMixed)

  Specified by:
    `setMixed` in interface `XSDComplexTypeDefinition`
  Parameters:
    `newMixed` - the new value of the 'Mixed' attribute.
  See Also:
    `XSDComplexTypeDefinition.isSetMixed()`, `XSDComplexTypeDefinition.unsetMixed()`, `XSDComplexTypeDefinition.isMixed()`

### unsetMixed

    public void unsetMixed()

  Specified by:
    `unsetMixed` in interface `XSDComplexTypeDefinition`
  See Also:
    `XSDComplexTypeDefinition.isSetMixed()`, `XSDComplexTypeDefinition.isMixed()`, `XSDComplexTypeDefinition.setMixed(boolean)`

### isSetMixed

    public boolean isSetMixed()

  Specified by:
    `isSetMixed` in interface `XSDComplexTypeDefinition`
  Returns:
    whether the value of the 'Mixed' attribute is set.
  See Also:
    `XSDComplexTypeDefinition.unsetMixed()`, `XSDComplexTypeDefinition.isMixed()`, `XSDComplexTypeDefinition.setMixed(boolean)`

### getContentAnnotation

    public XSDAnnotation getContentAnnotation()

  Specified by:
    `getContentAnnotation` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Content Annotation' containment reference.
  See Also:
    `XSDComplexTypeDefinition.setContentAnnotation(XSDAnnotation)`, `XSDPackage.getXSDComplexTypeDefinition_ContentAnnotation()`

### setContentAnnotation

    public void setContentAnnotation(XSDAnnotation newContentAnnotation)

  Specified by:
    `setContentAnnotation` in interface `XSDComplexTypeDefinition`
  Parameters:
    `newContentAnnotation` - the new value of the 'Content Annotation' containment reference.
  See Also:
    `XSDComplexTypeDefinition.getContentAnnotation()`

### basicSetContentAnnotation

    public NotificationChain basicSetContentAnnotation(XSDAnnotation newContentAnnotation,
                                                       NotificationChain msgs)

### getBaseTypeDefinition

    public XSDTypeDefinition getBaseTypeDefinition()

  Specified by:
    `getBaseTypeDefinition` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Base Type Definition' reference.
  See Also:
    `XSDComplexTypeDefinition.setBaseTypeDefinition(XSDTypeDefinition)`, `XSDPackage.getXSDComplexTypeDefinition_BaseTypeDefinition()`

### setBaseTypeDefinition

    public void setBaseTypeDefinition(XSDTypeDefinition newBaseTypeDefinition)

  Specified by:
    `setBaseTypeDefinition` in interface `XSDComplexTypeDefinition`
  Parameters:
    `newBaseTypeDefinition` - the new value of the 'Base Type Definition' reference.
  See Also:
    `XSDComplexTypeDefinition.getBaseTypeDefinition()`

### getContent

    public XSDComplexTypeContent getContent()

  Specified by:
    `getContent` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Content' containment reference.
  See Also:
    `XSDComplexTypeDefinition.setContent(XSDComplexTypeContent)`, `XSDPackage.getXSDComplexTypeDefinition_Content()`

### setContent

    public void setContent(XSDComplexTypeContent newContent)

  Specified by:
    `setContent` in interface `XSDComplexTypeDefinition`
  Parameters:
    `newContent` - the new value of the 'Content' containment reference.
  See Also:
    `XSDComplexTypeDefinition.getContent()`

### basicSetContent

    public NotificationChain basicSetContent(XSDComplexTypeContent newContent,
                                             NotificationChain msgs)

### getContentType

    public XSDComplexTypeContent getContentType()

  Specified by:
    `getContentType` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Content Type' reference.
  See Also:
    `XSDComplexTypeDefinition.setContentType(XSDComplexTypeContent)`, `XSDPackage.getXSDComplexTypeDefinition_ContentType()`

### getComplexType

    public XSDParticle getComplexType()

  Description copied from class: `XSDTypeDefinitionImpl`

  Specified by:
    `getComplexType` in interface `XSDTypeDefinition`
  Overrides:
    `getComplexType` in class `XSDTypeDefinitionImpl`
  Returns:
    the value of the 'Complex Type' reference.
  See Also:
    `XSDPackage.getXSDTypeDefinition_ComplexType()`

### setContentType

    public void setContentType(XSDComplexTypeContent newContentType)

  Specified by:
    `setContentType` in interface `XSDComplexTypeDefinition`
  Parameters:
    `newContentType` - the new value of the 'Content Type' reference.
  See Also:
    `XSDComplexTypeDefinition.getContentType()`

### getAttributeUses

    public EList<XSDAttributeUse> getAttributeUses()

  Specified by:
    `getAttributeUses` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Attribute Uses' reference list.
  See Also:
    `XSDPackage.getXSDComplexTypeDefinition_AttributeUses()`

### getAttributeContents

    public EList<XSDAttributeGroupContent> getAttributeContents()

  Specified by:
    `getAttributeContents` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Attribute Contents' containment reference list.
  See Also:
    `XSDPackage.getXSDComplexTypeDefinition_AttributeContents()`

### getAttributeWildcard

    public XSDWildcard getAttributeWildcard()

  Specified by:
    `getAttributeWildcard` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Attribute Wildcard' reference.
  See Also:
    `XSDComplexTypeDefinition.setAttributeWildcard(XSDWildcard)`, `XSDPackage.getXSDComplexTypeDefinition_AttributeWildcard()`

### setAttributeWildcard

    public void setAttributeWildcard(XSDWildcard newAttributeWildcard)

  Specified by:
    `setAttributeWildcard` in interface `XSDComplexTypeDefinition`
  Parameters:
    `newAttributeWildcard` - the new value of the 'Attribute Wildcard' reference.
  See Also:
    `XSDComplexTypeDefinition.getAttributeWildcard()`

### getAttributeWildcardContent

    public XSDWildcard getAttributeWildcardContent()

  Specified by:
    `getAttributeWildcardContent` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Attribute Wildcard Content' containment reference.
  See Also:
    `XSDComplexTypeDefinition.setAttributeWildcardContent(XSDWildcard)`, `XSDPackage.getXSDComplexTypeDefinition_AttributeWildcardContent()`

### setAttributeWildcardContent

    public void setAttributeWildcardContent(XSDWildcard newAttributeWildcardContent)

  Specified by:
    `setAttributeWildcardContent` in interface `XSDComplexTypeDefinition`
  Parameters:
    `newAttributeWildcardContent` - the new value of the 'Attribute Wildcard Content' containment reference.
  See Also:
    `XSDComplexTypeDefinition.getAttributeWildcardContent()`

### basicSetAttributeWildcardContent

    public NotificationChain basicSetAttributeWildcardContent(XSDWildcard newAttributeWildcardContent,
                                                              NotificationChain msgs)

### createElement

    public org.w3c.dom.Element createElement()

  Overrides:
    `createElement` in class `XSDConcreteComponentImpl`

### createContentElementPair

    protected org.w3c.dom.Element[] createContentElementPair()

### createDerivationElement

    protected org.w3c.dom.Element createDerivationElement()

### considerAllContainsForBestConcreteComponent

    protected boolean considerAllContainsForBestConcreteComponent()

  Overrides:
    `considerAllContainsForBestConcreteComponent` in class `XSDConcreteComponentImpl`

### patch

    protected void patch()

  Overrides:
    `patch` in class `XSDTypeDefinitionImpl`

### handleAnalysis

    protected void handleAnalysis()

  Overrides:
    `handleAnalysis` in class `XSDTypeDefinitionImpl`

### isEmptyContent

    protected boolean isEmptyContent(XSDParticle xsdParticle)

### validate

    public void validate()

  Description copied from interface: `XSDConcreteComponent`
  Validates whether this component conforms to the constraints defined in the XML Schema standard. `Diagnostics` are produced to report any problems. The effect of calling this for a component not directly or indirectly contained by a `schema` is undefined, and is likely to result in null pointer exceptions.

  Specified by:
    `validate` in interface `XSDConcreteComponent`
  Overrides:
    `validate` in class `XSDConcreteComponentImpl`
  See Also:
    `XSDConcreteComponent.getDiagnostics()`, `XSDConcreteComponent.clearDiagnostics()`

### getProhibitedAttributeURIs

    protected static java.util.Map<java.lang.String,XSDAttributeDeclaration> getProhibitedAttributeURIs(XSDComplexTypeDefinition xsdComplexTypeDefinition)

### getProhibitedAttributes

    protected static java.util.Map<java.lang.String,XSDAttributeDeclaration> getProhibitedAttributes(java.util.Collection<XSDAttributeGroupContent> xsdAttributeContents)

### validateAttributeGroup

    public static void validateAttributeGroup(XSDConcreteComponentImpl xsdConcreteComponent,
                                              XSDWildcard containedWildcard,
                                              EList<XSDAttributeUse> baseXSDAttributeUses,
                                              EList<XSDAttributeUse> xsdAttributeUses,
                                              XSDWildcard baseXSDWildcard,
                                              XSDWildcard xsdWildcard)

### reconcileAttributes

    protected void reconcileAttributes(org.w3c.dom.Element changedElement)

  Overrides:
    `reconcileAttributes` in class `XSDNamedComponentImpl`

### handleNewBaseTypeDefinition

    protected XSDTypeDefinition handleNewBaseTypeDefinition(XSDTypeDefinition newBaseTypeDefinition)

### getAdoptionParentNode

    protected org.w3c.dom.Node getAdoptionParentNode(EReference eReference)

  Overrides:
    `getAdoptionParentNode` in class `XSDConcreteComponentImpl`

### getContentNodes

    protected java.util.Collection<org.w3c.dom.Element> getContentNodes(org.w3c.dom.Element changedElement)

  Overrides:
    `getContentNodes` in class `XSDConcreteComponentImpl`

### handleUnreconciledElement

    protected void handleUnreconciledElement(org.w3c.dom.Element child,
                                             java.util.List<XSDConcreteComponent> newContents,
                                             java.util.List<XSDConcreteComponent> remainingContents)

  Overrides:
    `handleUnreconciledElement` in class `XSDConcreteComponentImpl`

### handleReconciliation

    protected void handleReconciliation(java.util.List<XSDConcreteComponent> newContents,
                                        java.util.List<XSDConcreteComponent> remainingContents)

  Overrides:
    `handleReconciliation` in class `XSDConcreteComponentImpl`

### changeAttribute

    protected void changeAttribute(EAttribute eAttribute)

  Overrides:
    `changeAttribute` in class `XSDNamedComponentImpl`

### changeReference

    protected void changeReference(EReference eReference)

  Overrides:
    `changeReference` in class `XSDConcreteComponentImpl`

### abbreviate

    protected boolean abbreviate()

### findOrCreateContentElementPair

    protected org.w3c.dom.Element[] findOrCreateContentElementPair()

### getContentElementPair

    protected org.w3c.dom.Element[] getContentElementPair()

### adoptContent

    protected void adoptContent(EReference eReference,
                                XSDConcreteComponent xsdConcreteComponent)

  Overrides:
    `adoptContent` in class `XSDConcreteComponentImpl`

### orphanContent

    protected void orphanContent(EReference eReference,
                                 XSDConcreteComponent xsdConcreteComponent)

  Overrides:
    `orphanContent` in class `XSDConcreteComponentImpl`

### getBaseType

    public XSDTypeDefinition getBaseType()

  Description copied from interface: `XSDTypeDefinition`
  Returns the value of the 'Base Type' reference.

  This represents the same result as either the simple '`Base Type Definition`' reference or the complex '`Base Type Definition`' reference.

  Specified by:
    `getBaseType` in interface `XSDTypeDefinition`
  Overrides:
    `getBaseType` in class `XSDTypeDefinitionImpl`
  Returns:
    the value of the 'Base Type' reference.
  See Also:
    `XSDPackage.getXSDTypeDefinition_BaseType()`

### getRootType

    public XSDTypeDefinition getRootType()

  Description copied from interface: `XSDTypeDefinition`
  Returns the value of the 'Root Type' reference.

  This walks the `base types` until it hits that one that has the ur-type definition as it's base type.

  Specified by:
    `getRootType` in interface `XSDTypeDefinition`
  Overrides:
    `getRootType` in class `XSDTypeDefinitionImpl`
  Returns:
    the value of the 'Root Type' reference.
  See Also:
    `XSDPackage.getXSDTypeDefinition_RootType()`

### getRootTypeDefinition

    public XSDTypeDefinition getRootTypeDefinition()

  Description copied from interface: `XSDComplexTypeDefinition`
  Returns the value of the 'Root Type Definition' reference.

  This walks the `base type definitions` until it hits that one that has the ur-type definition as it's base type definition.

  Specified by:
    `getRootTypeDefinition` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Root Type Definition' reference.
  See Also:
    `XSDPackage.getXSDComplexTypeDefinition_RootTypeDefinition()`

### getSyntheticParticle

    public XSDParticle getSyntheticParticle()

  Specified by:
    `getSyntheticParticle` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Synthetic Particle' containment reference.
  See Also:
    `XSDComplexTypeDefinition.setSyntheticParticle(XSDParticle)`, `XSDPackage.getXSDComplexTypeDefinition_SyntheticParticle()`

### basicSetSyntheticParticle

    public NotificationChain basicSetSyntheticParticle(XSDParticle newSyntheticParticle,
                                                       NotificationChain msgs)

### setSyntheticParticle

    public void setSyntheticParticle(XSDParticle newSyntheticParticle)

  Specified by:
    `setSyntheticParticle` in interface `XSDComplexTypeDefinition`
  Parameters:
    `newSyntheticParticle` - the new value of the 'Synthetic Particle' containment reference.
  See Also:
    `XSDComplexTypeDefinition.getSyntheticParticle()`

### getSyntheticWildcard

    public XSDWildcard getSyntheticWildcard()

  Specified by:
    `getSyntheticWildcard` in interface `XSDComplexTypeDefinition`
  Returns:
    the value of the 'Synthetic Wildcard' containment reference.
  See Also:
    `XSDComplexTypeDefinition.setSyntheticWildcard(XSDWildcard)`, `XSDPackage.getXSDComplexTypeDefinition_SyntheticWildcard()`

### basicSetSyntheticWildcard

    public NotificationChain basicSetSyntheticWildcard(XSDWildcard newSyntheticWildcard,
                                                       NotificationChain msgs)

### setSyntheticWildcard

    public void setSyntheticWildcard(XSDWildcard newSyntheticWildcard)

  Specified by:
    `setSyntheticWildcard` in interface `XSDComplexTypeDefinition`
  Parameters:
    `newSyntheticWildcard` - the new value of the 'Synthetic Wildcard' containment reference.
  See Also:
    `XSDComplexTypeDefinition.getSyntheticWildcard()`

### eInverseRemove

    public NotificationChain eInverseRemove(InternalEObject otherEnd,
                                            int featureID,
                                            NotificationChain msgs)

  Overrides:
    `eInverseRemove` in class `XSDTypeDefinitionImpl`

### eGet

    public java.lang.Object eGet(int featureID,
                                 boolean resolve,
                                 boolean coreType)

  Specified by:
    `eGet` in interface `InternalEObject`
  Overrides:
    `eGet` in class `XSDTypeDefinitionImpl`

### eSet

    public void eSet(int featureID,
                     java.lang.Object newValue)

  Specified by:
    `eSet` in interface `InternalEObject`
  Overrides:
    `eSet` in class `XSDTypeDefinitionImpl`

### eUnset

    public void eUnset(int featureID)

  Specified by:
    `eUnset` in interface `InternalEObject`
  Overrides:
    `eUnset` in class `XSDTypeDefinitionImpl`

### eIsSet

    public boolean eIsSet(int featureID)

  Specified by:
    `eIsSet` in interface `InternalEObject`
  Overrides:
    `eIsSet` in class `XSDTypeDefinitionImpl`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `XSDNamedComponentImpl`

### getSimpleType

    public XSDSimpleTypeDefinition getSimpleType()

  Description copied from interface: `XSDTypeDefinition`
  Returns the value of the 'Simple Type' reference.

  This represents either the '`Simple Type Definition`' itself or the complex '`Content Type`' reference, if it is `simple`.

  Specified by:
    `getSimpleType` in interface `XSDTypeDefinition`
  Overrides:
    `getSimpleType` in class `XSDTypeDefinitionImpl`
  Returns:
    the value of the 'Simple Type' reference.
  See Also:
    `XSDPackage.getXSDTypeDefinition_SimpleType()`

### getStringLexicalFinal

    public java.lang.String getStringLexicalFinal()

  Description copied from interface: `XSDComplexTypeDefinition`
  Returns the String value of the '`Lexical Final`' attribute list.

  Specified by:
    `getStringLexicalFinal` in interface `XSDComplexTypeDefinition`
  Returns:
    the String value of the 'Lexical Final' attribute list.
  See Also:
    `XSDComplexTypeDefinition.getLexicalFinal()`, `XSDComplexTypeDefinition.setStringLexicalFinal(java.lang.String)`

### setStringLexicalFinal

    public void setStringLexicalFinal(java.lang.String finalDefault)

  Description copied from interface: `XSDComplexTypeDefinition`
  Sets the String value of the '`Lexical Final`' attribute.

  Specified by:
    `setStringLexicalFinal` in interface `XSDComplexTypeDefinition`
  Parameters:
    `finalDefault` - the new value of the 'Lexical Final' attribute.
  See Also:
    `XSDComplexTypeDefinition.getLexicalFinal()`, `XSDComplexTypeDefinition.getStringLexicalFinal()`

### getStringFinal

    public java.lang.String getStringFinal()

  Description copied from interface: `XSDComplexTypeDefinition`
  Returns the String value of the '`Final`' attribute list.

  Specified by:
    `getStringFinal` in interface `XSDComplexTypeDefinition`
  Returns:
    the String value of the 'Final' attribute list.
  See Also:
    `XSDComplexTypeDefinition.getFinal()`

### getStringBlock

    public java.lang.String getStringBlock()

  Description copied from interface: `XSDComplexTypeDefinition`
  Returns the String value of the '`Block`' attribute list.

  Specified by:
    `getStringBlock` in interface `XSDComplexTypeDefinition`
  Returns:
    the String value of the 'Block' attribute list.
  See Also:
    `XSDComplexTypeDefinition.getBlock()`, `XSDComplexTypeDefinition.setStringBlock(java.lang.String)`

### setStringBlock

    public void setStringBlock(java.lang.String block)

  Description copied from interface: `XSDComplexTypeDefinition`
  Sets the String value of the '`Block`' attribute.

  Specified by:
    `setStringBlock` in interface `XSDComplexTypeDefinition`
  Parameters:
    `block` - the new value of the 'Block' attribute.
  See Also:
    `XSDComplexTypeDefinition.getBlock()`, `XSDComplexTypeDefinition.getStringBlock()`

### getStringProhibitedSubstitutions

    public java.lang.String getStringProhibitedSubstitutions()

  Description copied from interface: `XSDComplexTypeDefinition`
  Returns the String value of the '`Prohibited Substitutions`' attribute list.

  Specified by:
    `getStringProhibitedSubstitutions` in interface `XSDComplexTypeDefinition`
  Returns:
    the String value of the 'Prohibited Substitutions' attribute list.
  See Also:
    `XSDComplexTypeDefinition.getProhibitedSubstitutions()`

### getBadTypeDerivation

    public XSDTypeDefinition getBadTypeDerivation(XSDTypeDefinition xsdTypeDefinition,
                                                  boolean extension,
                                                  boolean restriction)

  Description copied from interface: `XSDTypeDefinition`
  Returns the first type between this and the given one, that derives from it's base in a way not permitted as constrained by Type Derivation OK Complex and Simple. The result is `null` if the derivation is valid; the result is the `UR-type`, if this type is not related to the given type; otherwise, the result is the base with the blocked derivation method.

  Specified by:
    `getBadTypeDerivation` in interface `XSDTypeDefinition`
  Overrides:
    `getBadTypeDerivation` in class `XSDTypeDefinitionImpl`
  Returns:
    the first type between this and the given one, that derives from it's base in a way not permitted.

### cloneConcreteComponent

    public XSDConcreteComponent cloneConcreteComponent(boolean deep,
                                                       boolean shareDOM)

  Description copied from interface: `XSDConcreteComponent`
  Creates a clone of the component. The clone may be deep and may share the DOM of this component.

  Specified by:
    `cloneConcreteComponent` in interface `XSDConcreteComponent`
  Overrides:
    `cloneConcreteComponent` in class `XSDConcreteComponentImpl`
  Parameters:
    `deep` - whether the clone should be deep.
    `shareDOM` - whether the clone should share the original DOM
  Returns:
    a clone of the component.

Copyright 2001-2006 IBM Corporation and others. All Rights Reserved.